package Zebrabidea;

public class Zebrabidea {
	private int kp=0;
	private int kz=0;
	private int kk=0;
	private int op=0;
	private int oz=0;
	private int ok;
	private boolean b=false;
	
	private int MAX;
	private int Atas;
	private Pantaila p;
	
	public Zebrabidea (int MAX, int Atas, Pantaila p) {
		this.MAX=MAX;
		this.Atas=Atas;
		this.p=p;
		this.ok=MAX;
	}
	
	synchronized public void oIritsi (int id) throws InterruptedException{
		//oinezkoa[PR].iritsi		-> ZEBRABIDEA[op][oz+1][kp][kz][ok][kk][b]
		oz++;
		p.zebrabidea(kp, kz, op, oz, id+1, kk, ok, b);
	}
	synchronized public void oPasatu (int id) throws InterruptedException{
		// when(kp==0 && (kz<MAX || ok<MAX))							oinezkoa[PR].pasatu		-> if(b==1&&ok==MAX-1) then ZEBRABIDEA[op+1][oz-1][kp][kz][ok+1][0][b]
		//																											   else if (b==1) then ZEBRABIDEA[op+1][oz-1][kp][kz][ok+1][kk][b]
		//																											   else ZEBRABIDEA[op+1][oz-1][kp][kz][ok][kk][b]
		while(!(kp==0 && (kz<Atas || ok<MAX))) wait();
		if(b==true&&ok==MAX-1) {
			op++;
			oz--;
			ok++;
			kk=0;
		}else if(b==true) {
			op++;
			oz--;
			ok++;
		}else {
			op++;
			oz--;
		}
		p.zebrabidea(kp, kz, op, oz, id+1, kk, ok, b);
	}

	synchronized public void oJoan (int id) throws InterruptedException{
		//oinezkoa[PR].joan		-> ZEBRABIDEA[op-1][oz][kp][kz][ok][kk][b]
		op--;
		p.zebrabidea(kp, kz, op, oz, id+1, kk, ok, b);
		notifyAll(); //kotxeak esnatu behar dira
	}

	synchronized public void kIritsi (int id) throws InterruptedException{
		//kotxea[KR].iritsi		-> if(kz==MAX) then ZEBRABIDEA[op][oz][kp][kz+1][ok][kk][1]
		//									   else ZEBRABIDEA[op][oz][kp][kz+1][ok][kk][0]
		if(kz>=Atas) {
			b=true;
			kz++;
		}else {
			b=false;
			kz++;
		}
		p.zebrabidea(kp, kz, op, oz, id, kk, ok, b);
	}

	synchronized public void kPasatu (int id) throws InterruptedException{
		//when(op==0 && (oz==0 || (kz>=MAX && kk<MAX)))			    kotxea[KR].pasatu		-> if (b==1&&kk==MAX-1) then ZEBRABIDEA[op][oz][kp+1][kz-1][0][kk+1][b]
		//																								 			else if (b==1) then ZEBRABIDEA[op+1][oz-1][kp][kz][ok][kk+1][b]
		//																								 			else ZEBRABIDEA[op][oz][kp+1][kz-1][ok][kk][b]
		while(!(op==0 && (oz==0 || (kz>=Atas && kk<MAX)))) wait();
		if(b==true&&kk==MAX-1) {
			kp++;
			kz--;
			kk++;
			ok=0;
		}else if(b==true){
			kp++;
			kz--;
			kk++;
		}else {
			kp++;
			kz--;
		}
		p.zebrabidea(kp, kz, op, oz, id, kk, ok, b);		
	}

	synchronized public void kJoan (int id) throws InterruptedException{
		//kotxea[KR].joan			-> ZEBRABIDEA[op][oz][kp-1][kz][ok][kk][b]
		kp--;
		p.zebrabidea(kp, kz, op, oz, id, kk, ok, b);
		notifyAll(); //oinezkoak esnatu behar dira
	}														
}
